/*Backward euler*/
var method = (function() { return function (h, A, b, y0) {

	var ea = 1/(1 - A*h);
	var eb = ea*h*b;
	
	var time = 0;
	var y_old = y0;

	return function() {
		time += h;
		var y_n = ea * y_old + eb;
		y_old = y_n;
		return {"time": time, "value": y_n};
	}
}})();
method.title = "Implicit Euler";
