/* Explicit Runge-Kutta, order 4 */
var method = (function() { return function (h, A, b, y0) {

	var time = 0;
	var y_old = y0;

	return function() {
		time += h;
		var k1 = (A * (y_old         ) + b)*h;
		var k2 = (A * (y_old + (k1/2)) + b)*h;
		var k3 = (A * (y_old + (k2/2)) + b)*h;
		var k4 = (A * (y_old + (k3  )) + b)*h;

		var y_n = y_old + (k1 + (2 * k2) + (2 * k3) + k4)/6;


		y_old = y_n;
		return {"time": time, "value": y_n};
	}
}})();
method.title = "ERK4";
