/* Explicit Runge-Kutta, order 1, euler */
var method = (function() { return function (h, A, b, y0) {

	var time = 0;
	var y_old = y0;

	return function() {
		time += h;
		var k1 = (A*y_old+b)*h;
		var y_n = y_old + k1;

		y_old = y_n;
		return {"time": time, "value": y_n};
	}
}})();
method.title = "Euler's method";
