/*Lobatto IIIC, order 2*/
var method = (function(){return function (h, A, b, y0) {

	var a11 =  1/2;
	var a12 = -1/2;
	var a21 =  1/2
	var a22 =  1/2;
	var b1 =   1/2;
	var b2 =   1/2;

	var e1 = 1/(1-A*h*a11)
	var e2 = 1/(1-A*h*a22)
	var m1 = (1/(1-(e1*A*e2*A*h*h*a12*a21))) * e1*A*(1+e2*h*a12);
	var m2 = (1/(1-(e2*A*e1*A*h*h*a21*a12))) * e2*A*(1+e1*h*a21);
	var n1 = (1/(1-(e1*A*e2*A*h*h*a12*a21))) * e1 * (1 + A * e2 * h * a12);
	var n2 = (1/(1-(e2*A*e1*A*h*h*a21*a12))) * e2 * (1 + A * e1 * h * a21);
	var n1b = n1*b;
	var n2b = n2*b;

	var time = 0;
	var y_old = y0;

	return function() {
		time += h;
		var k1 = m1*y_old + n1b;
		var k2 = m2*y_old + n2b;
		var y_n = y_old + (k1 * h * b1) + (k2 * h * b2);
		y_old = y_n;
		return {"time": time, "value": y_n};
	}
}})();
method.title = "Lobatto IIIC, order 2";
