/* Explicit Runge-Kutta, order 4 */
var method = (function() { return function (h, A, b, y0) {

	var time = 0;
	var y_old = $M(y0.elements);

	return function() {
		time += h;
		var k1 = A.x(y_old               ).add(b).x(h);
		var k2 = A.x(y_old.add(k1.x(0.5))).add(b).x(h);
		var k3 = A.x(y_old.add(k2.x(0.5))).add(b).x(h);
		var k4 = A.x(y_old.add(k3       )).add(b).x(h);

		var y_n = y_old.add((k1.add(k2.x(2)).add(k3.x(2)).add(k4)).x(1/6));


		y_old = y_n;
		return {"time": time, "value": y_n};
	}
}})();
method.title="ERK4";
