/* Explicit Runge-Kutta, order 1, euler */
var method = (function() { return function (h, A, b, y0) {

	var time = 0;
	var y_old = $M(y0.elements);

	return function() {
		time += h;
		var k1 = A.x(y_old).add(b).x(h);
		var y_n = y_old.add(k1);

		y_old = y_n;
		return {"time": time, "value": y_n};
	}
}})();
method.title = "Euler's method"
