
var storage = function() {
	var debug = true;

	var load = function(obj, rev, callback) {
		var client = new XMLHttpRequest();
		client.onreadystatechange = function() {
			if (debug) console.log("storage: readyState: " + this.readyState);
			if (this.readyState == this.DONE) {
				if (debug) console.log("storage: aquired object");
				callback(this.responseText);
			}
		};
		var fd = new FormData();
		fd.append("obj", obj);
		if (rev !== undefined) fd.append("rev", rev);
		client.open("POST", "/resource/get");
		client.send(fd);
		if (debug) console.log("storage: requesting object: " + obj);
	}

	var list = function(callback) {
		var client = new XMLHttpRequest();
		client.onreadystatechange = function() {
			if (debug) console.log("storage: readyState: " + this.readyState);
			if (this.readyState == this.DONE) {
				if (debug) console.log("storage: aquired object list");
				var data = JSON.parse(this.responseText);
				callback(data);
			}
		};
		client.open("GET","/resource/list");
		client.send();
		if (debug) console.log("storage: requesting object list");
	}

	var store = function(obj, rev, data) {
		var client = new XMLHttpRequest();
		var fd = new FormData();
		fd.append("obj", obj);
		if (rev !== undefined) fd.append("rev", rev);
		fd.append("data", data);
		client.open("POST", "/resource/add");
		if (debug) console.log("storage: sending: \"" + obj + "\": " + data);
		client.send(fd);
	}


	return {
		load: load, 
		list: list,
		store: store
	};

}();

var adder = function() {
	var debug = true;
	var frame = function(){
		if (debug) console.log("Adder: Creating interface");
		var adder = document.createElement("span");
		var title = document.createElement("h2");
		var titletext = document.createTextNode("Create object");
		var objectname = document.createElement("input");
		var objectdata = document.createElement("textarea");
		var objectsend = document.createElement("input");
		objectname.setAttribute("type","text");
		objectsend.setAttribute("type","button");
		objectsend.setAttribute("value","Store");
		title.appendChild(titletext);
		adder.appendChild(title);
		adder.appendChild(document.createTextNode("Objectname:"));
		adder.appendChild(objectname);
		adder.appendChild(document.createElement("br"));
		adder.appendChild(objectdata);
		adder.appendChild(document.createElement("br"));
		adder.appendChild(objectsend);
		adder.setAttribute("class","tester");
		objectsend.onclick=function(){
			storage.store(objectname.value,"",objectdata.value);
		};
		return adder;
	}();
	document.body.appendChild(frame);
};

var loader = function() {
	var debug = true;
	var display = {};
	var getDisplay = function(obj) {
		if (display[obj] === undefined) {
			display[obj] = newDisplay(obj);
		}
		return display[obj];
	}

	var newDisplay = function(obj) {
		if (debug) console.log("loader: creating new diplay for \"" + obj + "\"");
		var loader = document.createElement("span");
		var title = document.createElement("h2");
		var titletext = document.createTextNode(obj);
		var content = document.createElement("code");
		title.appendChild(titletext);
		loader.appendChild(title);
		loader.appendChild(content);
		loader.setAttribute("class","tester");
		document.body.appendChild(loader);
		return function(data) {
			content.innerText = data;
		}
	}

	return function(obj) {
		if (debug) console.log("loader: diplaying \"" + obj + "\"");
		storage.load(obj,"",getDisplay(obj));
	};
}();

var lister = function() {
	var debug = true;

	var list = function(){
		var lister = document.createElement("span");
		var title = document.createElement("h2");
		var titletext = document.createTextNode("Objectlist");
		var list = document.createElement("ul");
		var button = document.createElement("input");
		button.setAttribute("type","button");
		button.setAttribute("class","button");
		button.setAttribute("value","update");
		button.onclick = function(){update()};
		title.appendChild(titletext);
		list.setAttribute("id","objectlist");
		lister.appendChild(title);
		lister.appendChild(button);
		lister.appendChild(list);
		lister.setAttribute("class","tester");
		document.body.appendChild(lister);
		return list;
	}();

	var render = function(data) {
		if (debug) console.log("rendering list:" + data);
		var newlist = list.cloneNode(false);
		data.map(function(obj){
			var item = document.createElement('li');
			item.innerText = obj;
			item.onclick = function(){loader(obj)};
			newlist.appendChild(item);
		});
		list.parentNode.replaceChild(newlist,list);
		list = newlist;
	}
	
	var update = function() {
		storage.list(function(data) {
			if (debug) console.log("got list");
			render(data.List);
		});
	};
	update();
}

var init = function() {
	var debug = true;
	var readyfunc = function() {
		adder();
		lister();
	}

	document.onreadystatechange = function(){
		if (debug) console.log("document.readyState: " + document.readyState);
		if (document.readyState == "complete") readyfunc();
	}

}();
