

define(["gui/tabarea", "editor/editors"], function(tabArea, editors) {
	return new function() {
		var API = this;
		this.activeWidget = undefined;
		
		var handleKeypress = function(event) {
			if(API.activeWidget){
				if(event.which == 9 && API.activeWidget.suppressTab) { 
					if(event.preventDefault) event.preventDefault();
				}
				return API.activeWidget.handleKeypress(event);
			}
			return false;
		}
		document.addEventListener("keydown", handleKeypress, false);
		this.openTab = function(widget, parameters) {
			if(typeof widget == "string") {
				var constructor = editors[widget];
				return new constructor(tabArea, parameters);
			}
			else {
				return new widget(tabArea, parameters); 
			}
		}
	}
});

