define(["mustache/mustache"], function(mst) {
	return function(canvas) {
		this.mustache = new mst(canvas);
		this.shape = 
			{path: [
				{type:"line"
				,points:[]}
			]
			,lineWidth: 2
			,closed: false
			,strokeStyle: "black"
			,fillStyle: false
			,subshapes: [
				{path: [
					{type:"line"
					,points:[
						{x:0,y:0},
						{x:1,y:0}
					]}
				]
				,closed: false
				,fillStyle: false
				,strokeStyle: "red"
				,lineWidth: 1
				,pos: {x:0,y:0}
				,dim: {x:1,y:1}
				}
			]
			,pos: {x: 0, y:0}
			,dim: {x: 1, y:1}
			,inverty: true
		}

		this.addValue = function(sample) {
			var points = this.shape.path[0].points;
			var res = this.res;
			var factor = 1;
			var shape = this.shape;

			for (var i = 0; i<res; i++) {
				points[i].value = points[i+1].value;
				points[i].time  = points[i+1].time;
			}

			points[res].value = sample.value;
			points[res].time = sample.time;
			points.forEach(function(point){
				point.x = shape.dim.x - ((sample.time - point.time) * factor);
				point.y = point.value;
			});
		}

		this.refresh = function() {
			this.mustache.clear();
			this.mustache.drawShape(this.shape);
		}

		this.res = 2000;
		this.win = 10000;
		this.shape.dim.x = this.mustache.canvas.width;
		this.shape.pos.y = this.mustache.canvas.height/2;
		for(var i = 0; i<=this.res; i++) {
			this.shape.path[0].points.push({x:(this.shape.dim.x*(i/this.res)),y:0});
		}
		this.shape.subshapes[0].path[0].points[1].x = this.shape.dim.x;
		this.shape.subshapes[0].pos.y = this.shape.pos.y;
	}
});
