
define([],function() {
	return function(parameters) {
		var Capacitor = this;
		if(parameters) {
			this.pos = parameters.pos || {x: 0, y: 0};
			this.angle = parameters.angle || 0;
			this.view = parameters.view;
		}
		else {
			this.pos = {x: 0, y: 0};
			this.angle = 0;
		}

		this.type = "capacitor";

		this.boundingPath = [
			{
				type: "line",
				points: [
					{x: -20,y: -60},
					{x: -20,y: 60},
					{x: 20,y: 60},
					{x: 20,y: -60}
				]
			}
		];

		this.fillColor = {value: "#FFFF80"};

		/*
		this.onMouseOver = function() {
			fillColor.value = "#FF8080";
		}
		this.onMouseOut = function() {
			fillColor.value = "#FFFF80";
		}
		*/
		this.select = function() {
			Capacitor.fillColor.value = "#FF8080";
		}
		this.deselect = function() { 
			Capacitor.fillColor.value = "#FFFF80";
		}
		var view = this.view;

		this.pins = [
			view.createPin({angle:Math.PI, pos:{x:0,y:-14}, length:36, parent: Capacitor}),
			view.createPin({angle:0, pos:{x:0,y:14}, length:36, parent: Capacitor})
		];
		/*
		this.pins = [
			new Pin({pos:{x:0,y:14}, length: 36}),
			new Pin({pos:{x:0,y:-14}, angle:Math.PI, length: 36})
		];
		*/

		this.shape = [
			this.pins[0],
			this.pins[1],
			new function() {
				this.pos = {x: 0, y: 10};
				this.strokeStyle = "#000000";
				this.fillStyle = Capacitor.fillColor;
				this.closed = true;
				this.path = [
					{
						type: "line",
						points: [
							{x: -20, y: 4},
							{x: -20, y: -4},
							{x: 20, y: -4},
							{x: 20, y: 4}
						]
					}
				]
			},
			new function() {
				this.pos = {x: 0, y: -10};
				this.strokeStyle = "#000000";
				this.fillStyle = Capacitor.fillColor;
				this.closed = true;
				this.path = [
					{
						type: "line",
						points: [
							{x: -20, y: 4},
							{x: -20, y: -4},
							{x: 20, y: -4},
							{x: 20, y: 4}
						]
					}
				]
			}
		];
	}
});
