

define([],function() {
	return function(parameters) {
		var Diode = this;
		if(parameters) {
			this.pos = parameters.pos || {x: 0, y: 0};
			this.angle = parameters.angle || 0;
			this.view = parameters.view;
		}
		else {
			this.pos = {x: 0, y: 0};
			this.angle = 0;
		}

		this.type = "diode";

		this.boundingPath = [
			{
				type: "line",
				points: [
					{x: -8, y: -60},
					{x: -8, y: 60},
					{x: 8, y: 60},
					{x: 8, y: -60}
				]
			}
		];

		this.fillColor = {value: "#FFFF80"};
		this.select = function() {
			Diode.fillColor.value = "#FF8080";
		}
		this.deselect = function() { 
			Diode.fillColor.value = "#FFFF80";
		}
		var view = this.view;

		this.pins = [
			view.createPin({angle:Math.PI, pos:{x:0,y:-20}, length:30, parent: Diode}),
			view.createPin({angle:0, pos:{x:0,y:20}, length:30, parent: Diode})
		];

		this.shape = [
			this.pins[0],
			this.pins[1],
			new function() {
				this.fillStyle = Diode.fillColor;
				this.strokeStyle = "#000000";
				this.closed = true;
				this.path = [
					{
						type: "line",
						points: [
							{x: 0, y: -13},
							{x: -18, y: 20},
							{x: 18, y: 20}
						]
					}
				]
			},
			new function() {
				this.fillStyle = Diode.fillColor;
				this.strokeStyle = "#000000";
				this.closed = true;
				this.path = [
					{
						type: "line",
						points: [
							{x: -18, y: -20},
							{x: -18, y: -13},
							{x: 18, y: -13},
							{x: 18, y: -20}
						]
					}
				]
			},
		];
	}
});
