
define(["resources/pin"],function(Pin) {
	return function(parameters) {
		var Ground = this;
		if(parameters) {
			this.pos = parameters.pos || {x: 0, y: 0};
			this.angle = parameters.angle || 0;
			this.view = parameters.view;
		}
		else {
			this.pos = {x: 0, y: 0};
			this.angle = 0;
		}

		var view = this.view;

		this.type = "ground";

		this.boundingPath = [
			{
				type: "line",
				points: [
					{x: -17,y: 0},
					{x: -17,y: 16},
					{x: 17,y: 16},
					{x: 17,y: 0}
				]
			}
		];
		this.pins = [
			view.createPin({angle:Math.PI, pos:{x:0,y:10}, length:10, parent: Ground}),
		];
		this.shape = [
			this.pins,
			new function() {
				this.shape = [
					new function() {
						this.strokeStyle = "000000";
						this.path = [
							{
								type: "line",
								points: [
									{x: -17, y: 10},
									{x: 17, y: 10}
								]
							},
							{
								type: "line",
								points: [
									{x: -12, y: 15},
									{x: 12, y: 15}
								]
							},
							{
								type: "line",
								points: [
									{x: -7, y: 20},
									{x: 7, y: 20}
								]
							}
						]
					}
				];
			}
		];
	}
});

