

define(["api", "resources/interfacesegment", "dojo/text!resources/interfaceconfig.html", "resources/interfaces/spi", "resources/interfaces/can"],
function(API, InterfaceSegment, InterfaceConfig, SPI, CAN) {
	return function(parameters) {
		var Interface = this;
		var view = parameters.view;
		var points = parameters.points || [];
		var numSegments = points.length-1;
		this.shape = [];
		this.netList = [];
		this.interfaceName = undefined;
		this.endpoints = [];
		this.selected = false;
		this.select = function() {
			Interface.shape.forEach(function(shape) {
				shape.strokeStyle = "#80FF80";
			});
			Interface.selected = true;
		}
		this.deselect = function() {
			Interface.shape.forEach(function(shape) {
				shape.strokeStyle = "#008000";
			});
			Interface.selected = false;
		}
		this.addEndpoint = function(endpoint) {
			if(Interface.endpoints.indexOf(endpoint) == -1) Interface.endpoints.push(endpoint);
			endpoint.netList = Interface.netList;
		}
		var configDialogContainer = document.createElement("div");
		configDialogContainer.innerHTML = InterfaceConfig;
		var configForm = configDialogContainer.querySelector("#interfaceConfigForm");
		var interfaceTypeSelector = configDialogContainer.querySelector("#interfaceType");
		configForm.onsubmit = function(event) {
			Interface.interfaceName = interfaceTypeSelector.children[interfaceTypeSelector.selectedIndex].value;
			if(Interface.interfaceName == "SPI") {
				SPI.call(Interface);
			}
			view.closeDialog();
		}
		var injectInterfaces = function() {
			while(interfaceTypeSelector.childElementCount) {
				interfaceTypeSelector.removeChild(interfaceTypeSelector.firstChild);
			}
			var createHtmlOption = function(name) {
				var newOption = document.createElement("option");
				newOption.value = name;
				newOption.innerText = name;
				return newOption;
			}
			interfaceTypeSelector.appendChild(createHtmlOption("I2C"));
			interfaceTypeSelector.appendChild(createHtmlOption("SPI"));
			interfaceTypeSelector.appendChild(createHtmlOption("CAN"));
			interfaceTypeSelector.appendChild(createHtmlOption("UART"));
			interfaceTypeSelector.appendChild(createHtmlOption("LIN"));
		}
		this.config = function() {
			injectInterfaces();
			view.showDialog(configDialogContainer);
		}
		this.edit = function() {
			if(Interface.editor == undefined) {
				Interface.editor = API.openTab("schematic", {title: "my interface"});
				Interface.editor.parentModule = Interface;
				Interface.editor.onClose.push(function() {
					Interface.editor = undefined;
				});
			}
			Interface.editor.show();
		}
		for(var i = 0; i < numSegments; i++) {
			this.shape.push(view.createInterfaceSegment(points[i], points[i+1]));
		}
		this.addInterfaceSegment = function(newSegment) {
			Interface.shape.push(newSegment);
			newSegment.interface = Interface;
		}
	}
});
