

define(["resources/text"], function(Text) {
	return function(parameters) {
		var InterfaceEndpoint = this;
		if(parameters) {
			this.pos = parameters.pos || {x: 0, y: 0};
			this.length = parameters.length || 25;
			this.angle = parameters.angle || 0;
			this.parent = parameters.parent || undefined;
			this.name = parameters.name || {value: "if"};
		}

		this.type = "interfaceendpoint";
		this.connectionPoint = {pos:{x: 0, y: InterfaceEndpoint.length}};
		this.interfaceArcPoint = {x:0, y: InterfaceEndpoint.length - 12};

		this.shape = [
			{
				strokeStyle:  "#FF0000",
				lineWidth: 2,
				closed: false,
				path: [
					{
						type: "line",
						points: [
							{x: 0, y: 0},
							InterfaceEndpoint.interfaceArcPoint
						]
					},
				]
			},
			{
				strokeStyle:  "#FF0000",
				lineWidth: 2,
				closed: false,
				path: [
					{
						type: "arc",
						pos: InterfaceEndpoint.connectionPoint.pos,
						radius: 12,
						start: Math.PI/8,
						end: Math.PI*(7/8),
						ccw: true
					}
				]
			},
			InterfaceEndpoint.connectionPoint,
			new Text({pos:{x:0,y:-5}, text: InterfaceEndpoint.name, alwaysUpright: true, angle: Math.PI/2, align: "right", font: "10pt monospace"})
		];
	}
});
