

define([],function() {
	return function(parameters) {
		var Mosfet = this;
		if(parameters) {
			this.pos = parameters.pos || {x: 0, y: 0};
			this.angle = parameters.angle || 0;
			this.view = parameters.view;
		}
		else {
			this.pos = {x: 0, y: 0};
			this.angle = 0;
		}

		this.type = "resistor";

		this.boundingPath = [
			{
				type: "line",
				points: [
					{x: -8, y: -60},
					{x: -8, y: 60},
					{x: 8, y: 60},
					{x: 8, y: -60}
				]
			}
		];

		this.fillColor = {value: "#FFFF80"};
		this.select = function() {
			Mosfet.fillColor.value = "#FF8080";
		}
		this.deselect = function() { 
			Mosfet.fillColor.value = "#FFFF80";
		}
		var view = this.view;

		this.pins = [
			view.createPin({angle:Math.PI, pos:{x:0,y:-25}, length:25, parent: Mosfet}),
			view.createPin({angle:0, pos:{x:0,y:25}, length:25, parent: Mosfet})
		];

		this.shape = [
			this.pins[0],
			this.pins[1],
			new function() {
				this.fillStyle = Mosfet.fillColor;
				this.strokeStyle = "#000000";
				this.closed = true;
				this.path = [
					{
						type: "line",
						points: [
							{x: -8, y: -25},
							{x: -8, y: 25},
							{x: 8, y: 25},
							{x: 8, y: -25}
						]
					}
				]
			}
		];
	}
});
