

define(["resources/pin", "resources/text", "resources/resistor"],function(Pin, Text, Resistor) {
	return function(parameters) {
		var OpAmp = this;
		if(parameters) {
			this.pos = parameters.pos || {x: 0, y: 0};
			this.angle = parameters.angle || 0;
			this.view = parameters.view;
		}
		else {
			this.pos = {x: 0, y: 0};
			this.angle = 0;
		}

		this.type = "opamp";

		this.boundingPath = [
			{
				type: "line",
				points: [
					{x: -85, y: -50},
					{x: -85, y: 50},
					{x: 85, y: 50},
					{x: 85, y: -50}
				]
			}
		];

		this.fillColor = {value: "#FFFF80"};
		this.select = function() {
			OpAmp.fillColor.value = "#FF8080";
		}
		this.deselect = function() { 
			OpAmp.fillColor.value = "#FFFF80";
		}
		var view = this.view;

		var invertingText = view.createComponent(Text, {text: "-", pos: {x: 0, y: -10}, baseline: "middle", align: "center", fixedAngle: true});
		var noninvertingText = view.createComponent(Text, {text: "+", pos: {x: 0, y: -10}, baseline: "middle", align: "center", fixedAngle: true});


		this.noninverting = view.createPin({angle:Math.PI/2, text: noninvertingText, name: "non-inverting", pos:{x:-50,y:-25}, length:25, parent: OpAmp});
		this.inverting = view.createPin({angle:Math.PI/2, text: invertingText, name: "inverting", pos:{x:-50,y: 25}, length:25, parent: OpAmp});
		this.output = view.createPin({angle:-Math.PI/2, name: "output", pos:{x:50,y: 0}, length:25, parent: OpAmp});

		this.pins = [this.noninverting, this.inverting, this.output];

		this.shape = [
			new function() {
				this.fillStyle = OpAmp.fillColor;
				this.strokeStyle = "#000000";
				this.closed = true;
				this.path = [
					{
						type: "line",
						points: [
							{x: -50, y: -50},
							{x: -50, y: 50},
							{x: 50, y: 0}
						]
					}
				]
			},
			this.pins
			//new Text({text: "+", pos: {x: -35, y: -25}, fixedAngle: true, baseline: "middle", align: "center"}),
			//new Text({text: "-", pos: {x: -35, y: 25}, fixedAngle: true, baseline: "middle", align: "center"})
		];
	}
});
