

define(["resources/text"], function(Text) {
	return function(parameters) {
		var Pin = this;
		if(parameters) {
			this.pos = parameters.pos || {x: 0, y: 0};
			this.length = parameters.length || 25;
			this.angle = parameters.angle || 0;
			this.parent = parameters.parent || undefined;
			this.name = parameters.name || {value: ""};
			this.text = parameters.text || undefined;
		}

		this.type = "pin";

		var pinText = undefined;

		if(this.text) {
			if(this.text.type == "text") {
				pinText = this.text;
			}
			else {
				pinText = new Text({pos:{x:0,y:-5}, text: Pin.text, alwaysUpright: true, angle: Math.PI/2, align: "right", font: "10pt monospace"})
			}
		}
		else {
			pinText = Pin.name;
		}

		this.connectionPoint = {pos:{x: 0, y: Pin.length}};

		this.shape = [
			{
				strokeStyle:  "#000000",
				lineWidth: 2,
				closed: false,
				path: [
					{
						type: "line",
						points: [
							{x: 0, y: 0},
							Pin.connectionPoint.pos
						]
					}
				]
			},
			Pin.connectionPoint,
			pinText
			//new Text({pos:{x:0,y:-5}, text: Pin.text, alwaysUpright: true, angle: Math.PI/2, align: "right", font: "10pt monospace"})
		];
	}
});
