
define(["resources/text"],function(Text) {
	return function(parameters) {
		var Supply = this;
		if(parameters) {
			this.pos = parameters.pos || {x: 0, y: 0};
			this.angle = parameters.angle || 0;
			this.view = parameters.view;
		}
		else {
			this.pos = {x: 0, y: 0};
			this.angle = 0;
		}

		this.type = "supply";

		this.boundingPath = [
			{
				type: "line",
				points: [
					{x: -8, y: -60},
					{x: -8, y: 60},
					{x: 8, y: 60},
					{x: 8, y: -60}
				]
			}
		];

		this.fillColor = {value: "#FFFF80"};
		this.select = function() {
			Supply.fillColor.value = "#FF8080";
		}
		this.deselect = function() { 
			Supply.fillColor.value = "#FFFF80";
		}
		var view = this.view;

		var positiveText = view.createComponent(Text, {text: "+", pos: {x: 0, y: -10}, baseline: "middle", align: "center", fixedAngle: true});
		var negativeText = view.createComponent(Text, {text: "-", pos: {x: 0, y: -10}, baseline: "middle", align: "center", fixedAngle: true});

		this.pins = [
			view.createPin({angle:Math.PI, pos:{x:0,y:-20}, text: positiveText, length:30, parent: Supply}),
			view.createPin({angle:0, pos:{x:0,y:20}, text: negativeText, length:30, parent: Supply})
		];

		this.shape = [
			//this.pins[0],
			//this.pins[1],
			new function() {
				this.fillStyle = Supply.fillColor;
				this.strokeStyle = "#000000";
				this.closed = true;
				this.path = [
					{
						type: "arc",
						pos: {x: 0, y: 0},
						radius: {value: 20},
						start: 0,
						end: 2*Math.PI,
						ccw: true
					}
				]
			},
			this.pins
		];
	}
});
