

define(["resources/wiresegment"], function(WireSegment) {

	return function(parameters) {
		var Wire = this;
		var view = parameters.view;
		var points = parameters.points || [];
		var numSegments = points.length-1;
		this.shape = [];
		this.endpoints = [];
		view.wireList.push(Wire);
		this.mergeWire = function(newWire) {
			if(!newWire) return;
			if(!newWire.shape) return;
			newWire.shape.forEach(function(wireSegment) {
				if(Wire.shape.indexOf(wireSegment) == -1) {
					Wire.addWireSegment(wireSegment);
					if(wireSegment.actionArea[0]) {
						wireSegment.actionArea[0].wire = Wire;
						console.log("overwriting action area wire");
					}
					if(wireSegment.actionArea[1]) {
						wireSegment.actionArea[1].wire = Wire;
						console.log("overwriting action area wire");
					}
				}
			});
			newWire.endpoints.forEach(function(endpoint) {
				if(Wire.endpoints.indexOf(endpoint) == -1) {
					Wire.addEndpoint(endpoint);
				}
			});
			var i;
			if((i = view.wireList.indexOf(newWire)) == -1) return;
			view.wireList.splice(i,1);
			if(view.ground == newWire) view.ground = Wire;
		}
		for(var i = 0; i < numSegments; i++) {
			this.shape.push(view.createWireSegment(points[i], points[i+1]));
		}
		this.addWireSegment = function(newSegment) {
			if(Wire.shape.indexOf(newSegment) != -1) return;
			Wire.shape.push(newSegment);
			newSegment.wire = Wire;
		}
		this.addEndpoint = function(endpoint) {
			if(Wire.endpoints.indexOf(endpoint) != -1) return false;
			Wire.endpoints.push(endpoint);
			endpoint.wire = Wire;
			return true;
		}
	}
});
