define(["lib/sylvester"],function() { return function (h, A, b, y0) {
	/*Lobatto*/
	var a11 =  1/2;
	var a12 = -1/2;
	var a21 =  1/2
	var a22 =  1/2;
	var b1 =   1/2;
	var b2 =   1/2;

	var E1 = Matrix.I(A.rows()).subtract(A.x(h*a11)).inverse();
	var E2 = Matrix.I(A.rows()).subtract(A.x(h*a22)).inverse();
	var M1 = (Matrix.I(E1.rows()).subtract(E1.x(A).x(E2).x(A).x(h*h*a12*a21))).inverse().x(E1).x(A).x(Matrix.I(E2.rows()).add(E2.x(h*a12)));
	var M2 = (Matrix.I(E1.rows()).subtract(E2.x(A).x(E1).x(A).x(h*h*a21*a12))).inverse().x(E2).x(A).x(Matrix.I(E1.rows()).add(E1.x(h*a21)));
	var N1 = (Matrix.I(E1.rows()).subtract(E1.x(A).x(E2).x(A).x(h*h*a12*a21))).inverse().x(E1).x(Matrix.I(E2.rows()).add(A.x(E2).x(h*a12)));
	var N2 = (Matrix.I(E1.rows()).subtract(E2.x(A).x(E1).x(A).x(h*h*a21*a12))).inverse().x(E2).x(Matrix.I(E1.rows()).add(A.x(E1).x(h*a21)));
	var N1b = N1.x(b);
	var N2b = N2.x(b);

	var time = 0;
	var y_old = y0;

	return function() {
		time += h;
		var Y_nm1 = $M(y_old.elements);
		var k1 = M1.x(Y_nm1).add(N1b);
		var k2 = M2.x(Y_nm1).add(N2b);
		var y_n = Y_nm1.add(k1.x(h*b1)).add(k2.x(h*b2));
		y_old = y_n;
		return {"time": time, "value": y_n};
	}
}});
