

define(["dojo/dom-construct", "dojo/_base/declare", "dijit/layout/ContentPane", "mustache/mustache", "widget/cadview/uicomponent"],
function(domConstruct, declare, ContentPane, mustache, uiComponent) {
	return declare([ContentPane], {
		style: "background-color: #FFFFFF; overflow: hidden; padding: 0px;",

		postCreate: function() {
			this.inherited(arguments);
			this.surface = domConstruct.create("canvas", {

			}, this.domNode);
			this.surface.onmousemove = this.onMouseMove.bind(this);
			this.context = this.surface.getContext("2d");
			this.mustache = new mustache(this.surface);
			this.uiComponents[1].pos.x = 300.5;
			this.uiComponents[1].fillStyle = "#00FF00";
			this.uiComponents[1].subshapes[0] = new uiComponent();
			this.uiComponents[1].subshapes[0].fillStyle = "#0000FF";
			this.uiComponents[1].subshapes[0].pos.y = 150;
		},

		uiComponents: [
			new uiComponent(),
			new uiComponent()
		],

		draw: function() {
			this.mustache.setView(-500, -300, 1, 1);
			this.uiComponents.forEach(function(component) {
				this.drawComponent(component);
			}.bind(this));
		},

		drawComponent: function(component) {
			this.mustache.drawShape(component);
		},

		onMouseMove: function(event) {
			ev = event;
			this.uiComponents.forEach(function(component) {
				if(this.mustache.isPointInShape({x: event.offsetX, y: event.offsetY}, component)) {
					component.fillStyle = "yellow";
				} else {
					component.fillStyle = "red";
				}
				this.mustache.drawShape(component);
			}.bind(this));
		},

		resize: function(arg) {
			this.inherited(arguments);
			try {
				this.surface.width = arg.w;
				this.surface.height = arg.h;
			} catch(e) {
			}
			this.draw();
		}
	});
});

