
define([],
function() {
	return function() {
		var args = arguments[0];
		var primaryGrid = args.primary || {color: "black", width: 1};
		var secondaryGrid = args.secondary || {color: "#A0A0A0", width: 1};
		var meshWidth = args.meshWidth || 1;
		var meshHeight = args.meshHeight || 1;
		var surfaceView = args.surfaceView;
		var width = surfaceView.getWidth();
		var height = surfaceView.getHeight();

		var setView = function(center, scale) { 
		
		}

		var primary = new function() {
			this.strokeStyle = primaryGrid.color;
			this.width = primaryGrid.width;
			this.path = [];
		}

		var secondary = new function() {
			this.strokeStyle = secondaryGrid.color;
			this.width = secondaryGrid.width;
			this.path = [];
		}

		var shape = [secondary, primary];

		var rebuildGrid = function() {
			width = surfaceView.getWidth();
			height = surfaceView.getHeight();
			primary.path = [];
			secondary.path = [];

			for(var i = 0; i < width/meshWidth; i++) { 
				secondary.path.push({
					type: "line",
					points: [
						{x: i*meshWidth+0.5+meshWidth/2, y: 0},
						{x: i*meshWidth+0.5+meshWidth/2, y: height}
					]
				});
			}
			for(var i = 0; i < height/meshHeight; i++) { 
				secondary.path.push({
					type: "line",
					points: [
						{x: 0, y: i*meshHeight+0.5+meshHeight/2},
						{x: width, y: i*meshHeight+0.5+meshHeight/2}
					]
				});
			}
			for(var i = 0; i < width/meshWidth; i++) { 
				primary.path.push({
					type: "line",
					points: [
						{x: i*meshWidth+0.5, y: 0},
						{x: i*meshWidth+0.5, y: height}
					]
				});
			}
			for(var i = 0; i < height/meshHeight; i++) { 
				primary.path.push({
					type: "line",
					points: [
						{x: 0, y: i*meshHeight+0.5},
						{x: width, y: i*meshHeight+0.5}
					]
				});
			}
			prim = primary;
		}

		return {
			"shape": shape,
			"width": width,
			"height": height,
			"meshHeight": meshHeight,
			"meshWidth": meshWidth,
			"primaryGrid": primaryGrid,
			"secondaryGrid": secondaryGrid,
			"rebuildGrid": rebuildGrid
		}
	}
});
