
define(["resources/resource"], function(resource) {
	return function(parameters) {
		this.pos = parameters.pos || {x: 0, y: 0};
		this.angle = parameters.angle || 0;

		this.mouseOver = false;
		this.selected = false;

		if(parameters.shape) {
			this.shape = new resource(parameters.shape, parameters.shapeParameters);
		} else {
			this.shape = new resource("schematic/resistor");
		}

		this.boundingShape = this.shape.boundingShape;

		this.select = function() {
			this.selected = true;
			this.shape.fillStyle = this.selectedFillStyle;
		}

		this.deselect = function() {
			this.selected = false;
			this.shape.fillStyle = this.idleFillStyle;
		}

		this.onMouseOver = function() {
			if(!this.mouseOver) {
				this.shape.fillStyle = "#00FF00";
				this.mouseOver = true;
			}
			if(this.selected) {
				this.fillStyle = "#00FF00";
			}
		};
		this.onMouseOut = function() {
			if(this.selected) this.shape.fillStyle = this.selectedFillStyle;
			else this.shape.fillStyle = this.idleFillStyle;
			this.mouseOver = false;
		};
	}
});
