

define(["mustache/mustache"],
function(Mustache) {
	var canvas = document.createElement("canvas");
	var context = canvas.getContext("2d");

	var tracePath = function(path) {
		context.beginPath();
		if(Array.isArray(path)) {
			path.forEach(function(segment) {
				switch (segment.type) {
				case "arc":
					context.arc(segment.x, segment.y, segment.r, segment.start, segment.end, segment.ccw);
					break;
				case "line":
					context.moveTo(segment.points[0].x, segment.points[0].y);
					segment.points.forEach(function(point){
						context.lineTo(point.x, point.y);
					});
					break;
				case "rect":
					context.rect(segment.x, segment.y, segment.w, segment.h);
					break;
				}
			});
		} else {
			console.log("path is not path!");
			pa = path;
		}
	}

	return function() {
		var uiComponent = this;
		this.globalPos = {x: 0, y: 0};
		this.globalAngle = 0;
		this.selected = false;
		this.select = function() {
			uiComponent.selected = true;
			uiComponent.fillColor.value = "#FF8080";
		}
		this.deselect = function() {
			uiComponent.selected = false;
			uiComponent.fillColor.value = "#FFFF80";
		}

		var onMouseOver = this.onMouseOver;
		var view = this.view;
		this.onMouseOver = function() {
			if(view) {
				if(view.currentEditorMode == view.editorModes.idleMode) {
					if(uiComponent.fillColor) {
						uiComponent.fillColor.value = "#FF8080";
					}
				}
			}
			if(uiComponent.shape) {
				if(Array.isArray(uiComponent.shape)) {
					uiComponent.shape.forEach(function(shape) {
						if(!shape) return;
						if(shape.onMouseOver)
							shape.onMouseOver();
					});
				}
				else {
					if(uiComponent.shape.onMouseOver)
						uiComponent.shape.onMouseOver();
				}
			}
			if(onMouseOver) onMouseOver();
		}

		var onMouseOut = this.onMouseOut;
		this.onMouseOut = function() {
			uiComponent.fillColor.value = "#FFFF80";
			if(onMouseOut) onMouseOut();
		}

		var onMouseDown = this.onMouseDown;
		this.onMouseDown = function(event) {
			if(uiComponent.view && uiComponent.view.currentEditorState && uiComponent.view.currentEditorState == uiComponent.view.editorModes.idleMode) {
				// select component
			}
			if(onMouseDown) onMouseDown(event);
		}
	}
});

