

define(["widget/surfaceviewmixin"], function(SurfaceView) {

	var Plot = function(surfaceLayer, parameters) {
		var fifo = [];
		var points = [];
		var plot = this;
		this.plotSurface = surfaceLayer;
		this.lineColor = parameters.lineColor;

		var storePoints = function() {
			points = points.concat(fifo);
			if(points.length > 10000) {
				var numItemsToRemove = points.length - 10000;
				points.splice(0, numItemsToRemove);
			}
			fifo = [];
		}

		this.redraw = function() {
			storePoints();
			surfaceLayer.clear();
			for(var i = 0; i < points.length-1; i++) {
				var newLine = {
					strokeStyle: plot.lineColor,
					path: [
						{
							type: "line",
							points: [points[i], points[i+1]]
						}
					]
				};
				surfaceLayer.draw(newLine);
				console.log("drawing line");
			}
		}
		this.addPoint = function(newPoint) {
			fifo.push(newPoint);
		}
	}

	return function() {
		if(!this.surfaceViewMixin) SurfaceView.call(this);

		var plotView = this;

		this.createPlot = function(parameters) {
			var newLayer = plotView.createLayer(parameters.name || "new plot", 0);
			var newPlot = new Plot(newLayer, parameters);
			return newPlot;
		}
	}
});

