
define(["dojo/_base/declare", "dojo/dom-construct", "dojo/dom-geometry", "dijit/layout/ContentPane", "widget/cadview/uicomponent", "dijit/_Widget"], 
function(declare, domConstruct, domGeometry, ContentPane, uiComponent, Widget) {
	return declare([Widget], {
		postCreate: function() {
			this.inherited(arguments);
			//console.log("done creating surface");
			this.canvas = domConstruct.create("canvas", {
				style: "left: 0px; top: 0px; width: 100%; height: 100%; position: absolute; background-color: #FFFFA0;",
				innerHTML: "Your browser does not support HTML5 canvas. "
			}, this.domNode);
			this.context = this.canvas.getContext("2d");
		},

		constructor: function() {
			//console.log("constructed surface");
		},

		drawShape: function(shape) {
			
			var canvas  = this.canvas;
			var context = this.context;
			context.save();
			context.translate(shape.pos.x, shape.pos.y);
			if (shape.inverty) {context.scale(1,-1)};
			mustache.tracePath(shape.path);
			if (shape.closed){
				context.closePath()
			}
			if (shape.fillStyle){
				context.fillStyle = shape.fillStyle;
				context.fill();
			}
			if (shape.strokeStyle){
				context.strokeStyle = shape.strokeStyle;
				context.lineWidth = shape.lineWidth;
				context.stroke();
			}
			context.restore();
			if (Array.isArray(shape.subshapes)) {shape.subshapes.forEach(mustache.drawShape)};
		},

		resize: function(arg) {
			this.canvas.width = arg.w;
			this.canvas.height = arg.h;
			this.inherited(arguments);
		}

	});
});

