
define(["widget/widgetbase", "dojo/dom-construct", "mustache/mustache"],
function(WidgetBase, domConstruct, Mustache) {
	return function(parentNode, args) {
		var surface;
		if(!args.layers) {

		}
		var surface = domConstruct.create("canvas", {});
		var context = surface.getContext("2d");
		var mustache = new Mustache(surface);
		var width, height;
		var clearCanvas = mustache.clearCanvas;
		var drawShape = mustache.drawShape;
		var resizeEvents = [
			function(ev) {
				surface.width = ev.w;
				surface.height = ev.h;
				width = ev.w;
				height = ev.h;
			}
		];
		var widgetContainer = new WidgetBase({
			closable: true,
			title: args.title || "surfaceview",
			content: surface,
			resizeEvents: resizeEvents
		});
		var domNode = widgetContainer.domNode;
		parentNode.addChild(widgetContainer);

		var addResizeEvent = function(event) {
			resizeEvents.push(event);
		}

		var getWidth = function() {return width;}
		var getHeight = function() {return height;}

		return {
			"addResizeEvent": addResizeEvent,
			"context": context,
			"surface": surface,
			"clearCanvas": clearCanvas,
			"drawShape": drawShape,
			"getWidth": getWidth,
			"getHeight": getHeight,
			"mustache": mustache
		}
	}
});
