
define(["dojo/dom-construct", "dojo/_base/declare", "gui/tabarea", "dijit/layout/ContentPane", "mustache/mustache", "widget/cadview/uicomponent", "api"],
function(domConstruct, declare, TabArea, ContentPane, mustache, uiComponent, API) {

	// Because dojo and dijit tries to hide away the beauty of javascript objects,
	// we create an object to encapsulate dojo functionality in it's own bubble to not contaminate the rest of the code.
	var DijitSurfaceBase = declare([ContentPane], {
		style: "background-color: #FFFFFF; overflow: hidden; padding: 0px;",

		constructor: function() {
			//this.resizeEvents = arguments.resizeEvents || [];
			//this.onShowEvents = arguments.onShowEvents || [];
			//this.content = arguments.content || null;
			this.onResizeFunc = arguments.onResizeFunc;
			this.onShowFunc = arguments.onShowFunc;
			this.onCloseFunc = arguments.onCloseFunc;
			//this.onShow = arguments.onShow;
			//this.onCreate = arguments.onCreate;
		},

		/*
		addResizeEvent: function(newEvent) {
			this.resizeEvents.push(newEvent);
		},
		addOnShowEvent: function(newEvent) {
			this.onShowEvents.push(newEvent);
		},
		postCreate: function() {
			this.inherited(arguments);
		},
		*/
		onShow: function() {
			this.inherited(arguments);
			if(this.onShowFunc) this.onShowFunc(arguments);
			/*
			this.onShowEvents.forEach(function(ev) {
				ev(arguments);
			});
			*/
		},

		resize: function(arg) {
			this.inherited(arguments);
			//this.width = arg.w;
			//this.height = arg.h;
			if(this.onResizeFunc) this.onResizeFunc(arg);
			/*
			this.resizeEvents.forEach(function(ev) {
				ev(arg);
			});
			*/
		},
		onClose: function() {
			this.inherited(arguments);
			if(this.onCloseFunc) this.onCloseFunc();
			return true;
		}
	});

	return function() {
		var widgetBase = this;
		if(this.widgetBaseMixin) return;

		// Object variables mixed into caller object:
		this.widgetWidth = 0;
		this.widgetHeight = 0;
		this.widgetBaseMixin = true;
		this.content = undefined;
		this.onResize = [];
		this.onClose = [];
		this.onShow = [];
		this.handleKeypress = function(event) {
			if(widgetBase.suppressKeypress) return;
			if(!widgetBase.currentEditorMode) return;
			if(widgetBase.currentEditorMode.keyBindings[event.which] != undefined) {
				widgetBase.currentEditorMode.keyBindings[event.which].call(widgetBase, event);
				return false;
			}
			else {
				//console.log("key " + event.which + " is not bound.");
			}
		}

		var onResizeTrigger = function(event) {
			widgetBase.widgetWidth = event.w;
			widgetBase.widgetHeight = event.h;
			widgetBase.onResize.forEach(function(ev) {
				ev.call(widgetBase, event);
			});
		}
		var onShowTrigger = function() {
			API.activeWidget = widgetBase;
			widgetBase.onShow.forEach(function(ev) {
				ev.call(widgetBase);
			});
		}
		var onCloseTrigger = function() {
			widgetBase.onClose.forEach(function(ev) {
				ev.call(widgetBase);
			});
		}

		this.init = function() {
			widgetBase.onResize.forEach(function(ev) {
				var size = {w: widgetBase.widgetWidth, h: widgetBase.widgetHeight};
				ev.call(widgetBase, size);
			});
		}

		var dijitSurfaceBase = new DijitSurfaceBase({
			closable: true,
			title: this.title,
			onResizeFunc: onResizeTrigger,
			onShowFunc: onShowTrigger,
			onCloseFunc: onCloseTrigger
		});

		this.show = function() {
			TabArea.selectChild(dijitSurfaceBase);
		}
		this.content = dijitSurfaceBase.domNode;

		this.parentNode.addChild(dijitSurfaceBase);

	}
});

