var mustache = new Object(null);

mustache.drawShape = function(shape) {
	var canvas  = mustache.canvas;
	var context = mustache.context;
	context.save();
	context.translate(shape.pos.x, shape.pos.y);
	if (shape.inverty) {context.scale(1,-1)};
	mustache.tracePath(shape.path);
	if (shape.closed){
		context.closePath()
	}
	if (shape.fillStyle){
		context.fillStyle = shape.fillStyle;
		context.fill();
	}
	if (shape.strokeStyle){
		context.strokeStyle = shape.strokeStyle;
		context.lineWidth = shape.lineWidth;
		context.stroke();
	}
	context.restore();
	if (Array.isArray(shape.subshapes)) {shape.subshapes.forEach(mustache.drawShape)};
}

mustache.clear = function() {
	var canvas  = mustache.canvas;
	var context = mustache.context;
	context.clearRect(0,0,canvas.width, canvas.height);
}

mustache.tracePath = function(path) {
	var canvas = this.canvas;
	var context = this.context;
	context.beginPath();
	path.forEach(function(segment){
		switch (segment.type) {
		case "arc":
			context.arc(segment.x, segment.y, segment.r, segment.start, segment.end, segment.ccw);
			break;
		case "line":
			segment.points.forEach(function(point){
				context.lineTo(point.x, point.y);
			});
			break;
		case "rect":
			context.rect(segment.x, segment.y, segment.w, segment.h);
			break;
		}
	});
}

mustache.init = function(canvas){
	var context = canvas.getContext("2d");

	mustache.canvas = canvas;
	mustache.context = context;

}

var doTimeout = function() {
	//setTimeout("doTimeout();", 10);
	var t = (new Date()).getTime();
	//plotter.addValue({value: 40*Math.sin(t/1000), time: t});
}

var doTimeout2 = function() {
	plotter.refresh();
	setTimeout("doTimeout2();", 50);
}
