
tissue = new Object(null);

if(tissue.ui == undefined) tissue.ui = new Object(null);

tissue.ui.makeResizable = function(win) {
	if(win == undefined) return;
		
	var resizeTop = new Element('div', {
		class: 'uiResizeTop'
	}).inject(win);
	var resizeBottom = new Element('div', {
		class: 'uiResizeBottom'
	}).inject(win);
	var resizeLeft = new Element('div', {
		class: 'uiResizeLeft'
	}).inject(win);
	var resizeRight = new Element('div', {
		class: 'uiResizeRight'
	}).inject(win);
	var resizeTopLeft = new Element('div', {
		class: 'uiResizeTopLeft'
	}).inject(win);
	var resizeTopRight = new Element('div', {
		class: 'uiResizeTopRight'
	}).inject(win);
	var resizeBottomLeft = new Element('div', {
		class: 'uiResizeBottomLeft'
	}).inject(win);
	var resizeBottomRight = new Element('div', {
		class: 'uiResizeBottomRight'
	}).inject(win);

	var addDragDownRightEvent = function() {
		new Drag(win, {
			handle: resizeBottomRight,
			onDrag: function() {
				win.onResize();
			},
			modifiers: {x: 'width', y: 'height'}
		});
	}

	var addDragDownLeftEvents = function() {
		new Drag(win, {
			handle: resizeBottomLeft,
			invert: true,
			onDrag: function() {
				win.onResize();
			},
			modifiers: {x: 'width', y: false}
		});

		new Drag(win, {
			handle: resizeBottomLeft,
			modifiers: {x: false, y: 'height'}
		});

		new Drag(win, {
			handle: resizeBottomLeft,
			modifiers: {x: 'left', y: false}
		});
	}
	
	var addDragLeftEvents = function() {
		new Drag(win, {
			handle: resizeLeft,
			invert: true,
			onDrag: function() {
				win.onResize();
			},
			modifiers: {x: 'width', y: false}
		});

		new Drag(win, {
			handle: resizeLeft,
			modifiers: {x: 'left', y: false}
		});
	}

	var addDragDownEvent = function() {
		new Drag(win, {
			handle: resizeBottom,
			onDrag: function() {
				win.onResize();
			},
			modifiers: {x: false, y: 'height'}
		});
	}

	var addDragRightEvent = function() {
		new Drag(win, {
			handle: resizeRight,
			onDrag: function() {
				win.onResize();
			},
			modifiers: {x: 'width', y: false}
		});
	}

	var addDragTopRightEvents = function() {
		new Drag(win, {
			handle: resizeTopRight,
			onDrag: function() {
				win.onResize();
			},
			modifiers: {x: 'width', y: false}
		});
		new Drag(win, {
			handle: resizeTopRight,
			invert: true,
			modifiers: {x: false, y: 'height'}
		});
		new Drag(win, {
			handle: resizeTopRight,
			modifiers: {x: false, y: 'top'}
		});
	}
	var addDragTopEvents = function() {
		new Drag(win, {
			handle: resizeTop,
			onDrag: function() {
				win.onResize();
			},
			invert: true,
			modifiers: {x: false, y: 'height'}
		});
		new Drag(win, {
			handle: resizeTop,
			modifiers: {x: false, y: 'top'}
		});
	}
	var addDragTopLeftEvents = function() {
		new Drag(win, {
			handle: resizeTopLeft,
			invert: true,
			onDrag: function() {
				win.onResize();
			},
			modifiers: {x: false, y: 'height'}
		});
		new Drag(win, {
			handle: resizeTopLeft,
			modifiers: {x: false, y: 'top'}
		});
		new Drag(win, {
			handle: resizeTopLeft,
			modifiers: {x: 'left', y: false}
		});
		new Drag(win, {
			handle: resizeTopLeft,
			invert: true,
			modifiers: {x: 'width', y: false}
		});
	}

	
	addDragDownRightEvent();
	addDragDownLeftEvents();
	addDragLeftEvents();
	addDragDownEvent();
	addDragRightEvent();
	addDragTopRightEvents();
	addDragTopEvents();
	addDragTopLeftEvents();
}

tissue.ui.createWindow = function(id, options) {

	// Create container for window
	var newWindowContainer = new Element('div', {
		class: 'uiContainer',
	}).inject($('workspace'));

	// Create window header
	var windowHeader = new Element('h1', {
		html: id
	}).inject(newWindowContainer);
	
	// Create a drag object for moving the window
	new Drag(newWindowContainer, {
		handle: windowHeader
	});
	
	// Create window
	var newWindow = new Element('div', {
		class: 'uiWindow'
	}).inject(newWindowContainer);

	newWindowContainer.onResize = function() {newWindow.onResize();}
	newWindow.onResize = function() {}
	tissue.ui.makeResizable(newWindowContainer);
	window.onresize = function(){newWindow.onResize();}
	
	if(options) {
		if(options.url) {
			//var req = new Request.HTML().get(options.url);
			newWindow.load(options.url);
		}
		else if(options.html) {
			newWindow.set('html', options.html);
		}
	}
	

	return newWindowContainer;
}

